<?php
$item_typ["attributes"]["expEmailSent"] =  
            array(
                "type"=>"INT",
                "form invisible",
                "default"=>"0"
            );
$item_typ["attributes"]["expirationTime"] =  
            array(
                "type"=>"INT",
                "text",
                "form invisible",
                "details",
                "default"=>"0"
            );
$item_typ["attributes"]["renewalNum"] =  
            array(
                "type"=>"INT",
                "form invisible",
            );
$item_typ["attributes"]["email"] =  
            array(
                "no column",
                "form invisible",
            );
$item_typ["attributes"]["picture"] =  
            array(
                "type"=>"VARCHAR",
                "file",
                "max" =>"250"
             );
$item_typ["attributes"]["keepPrivate"] =  
            array(
                "type"=>"INT",
                "bool",
                "default"=>"0"
            );
$item_typ[]="notools";

for( $i=0; $i<$variableFieldsNum; $i++ )
{
    $item_typ["attributes"]["col_$i"]=array("type"=>"TEXT",
                                            "form invisible");
}

if( $withShoppingCart ) 
{
    $item_typ["attributes"]["price"] =  
                array(
                    "type"=>"FLOAT",
                    "text",
                    "default"=>"0",
                    "list", 
                    "details"
                );
}

class Advertisement extends Item
{

// Ezzel itt a "Variable fields" linket tesszuk ki, nem a new toolt
function showNewTool($rights)
{
    global $lll,$gorumroll, $itemClassName;
    
    $s="";
    // csak a kategoriahoz tartozo adok listaja eseten tesszuk ki:
    if( $gorumroll->list==$itemClassName ) 
    {
        hasAdminRights( $isAdm );
        if( $isAdm )
        {
            $tempRoll = $gorumroll;
            $tempRoll->method = "modify_form";
            $tempRoll->list = "varfields";
            $tempRoll->rollid = 0;
            saveInFrom($tempRoll);
            $tempRoll->id = $gorumroll->rollid;//ua az id, mint a kategoriae
            $s.=$tempRoll->generAnchor($lll["variableFields"]);
        }
    }
    return $s;
}

function showModTool($rights)
{
    global $lll,$gorumroll, $allowModify;
    
    $s="";
    hasAdminRights( $isAdm );
    if( $isAdm && !$this->active )
    {
        $tempRoll = $gorumroll;
        $tempRoll->method="approve";
        $tempRoll->rollid = 0;
        saveInFrom($tempRoll);
        $tempRoll->id = $this->id;
        $s.=$tempRoll->generAnchor($lll["approve"])." | ";
    }
    if( !$isAdm && !$allowModify ) $s="";
    else $s.=Object::showModTool($rights);
    return $s;
}

function approve()
{
    global $lll,$gorumroll, $whatHappened, $infoText, $expiration;
    global $userClassName, $itemClassName, $categoryClassName;
    
    hasAdminRights( $isAdm );
    if( $isAdm )
    {
        load($this);
        $this->active=TRUE;
        $this->expEmailSent=FALSE;
        $this->expirationTime = time()+60*60*24*$expiration; 
        modify($this);
        $c = new $categoryClassName;
        $c->id = $this->cid;
        load($c);
        $c->increaseDirectItemNum();
        $whatHappened = "form_submitted";
        $infoText = $lll["adApproved"];
        
        // mailt kuldunk rola a tulajnak:
        $n = new Notification;
        $n->id = Notification_adApproved;
        $n->load();
        if( $n->active )
        {
            $tempRoll = new Roll;
            $tempRoll->list = $itemClassName;
            $tempRoll->method = "showdetails";
            $tempRoll->rollid = $this->id; 
            $url = $tempRoll->makeUrl("mixed");
            $owner = new $userClassName;
            $owner->id = $this->ownerId;
            load($owner);                   
            $n->send( $owner->email, $this->title, $url );
        }
    }
}

function delete( $whereFields="", $overrulePrivilege=FALSE, $fromCronJob=FALSE )
{
    global $lll, $infoText, $adAttDir, $userClassName, $gorumroll, $itemClassName;
    
    Item::delete($whereFields,$overrulePrivilege);
    // Ha az admin torolte ki az ad-et, akkor emailt kell kuldeni a 
    // tulajnak:
    hasAdminRights( $isAdm );
    // Ha a kategoria torleserol jutunk ide, nem kell levelet kuldeni:
    if( $isAdm && !$fromCronJob && $gorumroll->list==$itemClassName )
    {
        $n = new Notification;
        $n->id = Notification_adRejected;
        $n->load();
        if( $n->active )
        {
            $owner = new $userClassName;
            $owner->id = $this->ownerId;
            load($owner);
            if( isset($owner->email) && $owner->email )
            {
                $n->send( $owner->email, $this->title, "" ); //TODO: description
            }    
        }
    }
    if( $this->picture )
    {
        $ret=@unlink("$adAttDir/$this->id".".".$this->picture);
        if( defined("IMG_GIF") && function_exists("ImageTypes"))//van GD
        {
            $checkBits = array("gif"=>IMG_GIF, "jpg"=>IMG_JPG, 
                               "png"=>IMG_PNG);
            if( ImageTypes() & $checkBits[$this->picture] ) 
            {
                $ret=@unlink("$adAttDir/th_$this->id".".".$this->picture);
            }
        }
        if(!$ret) $infoText=sprintf($lll["cantdelfile"],$this->picture);
    }
}

function showListVal($attr)
{
    global $itemClassName, $gorumroll, $expiration, $lll;
    global $gorumuser, $gorumrecognised, $renewal, $item_typ;
    global $categoryClassName,$adAttDir, $withShoppingCart, $shoppingCartClassName;

    $s="";
    if ($attr=="title") {
        if( $gorumroll->method == "showhtmllist" )
        {
            $tempRoll = $gorumroll;
            $tempRoll->list = $itemClassName;
            $tempRoll->method = "showdetails";
            $tempRoll->rollid = $this->id;
            saveInFromFrom($tempRoll);
            $s=$tempRoll->generAnchor(replaceBadWords(htmlspecialchars($this->title)));
        }
        else
        {
            $s=replaceBadWords(htmlspecialchars($this->title));
        }
    }    
    elseif ($attr=="cName") {
        if( !$this->cName )
        {
            $cat = new $categoryClassName;
            $cat->id = $this->cid;
            load($cat);
            $this->cName = $cat->name;
        }
        $tempRoll = new Roll;
        $tempRoll->method = "showhtmllist";
        $tempRoll->list = $categoryClassName;
        $tempRoll->rollid = $this->cid;
        $s=$tempRoll->generAnchor(htmlspecialchars($this->cName), "itemtitle");
    }    
    elseif ($expiration && $attr=="expirationTime") 
    {
        if( $this->active )
        {
            //var_dump($this);
            $s=(int)(round(($this->expirationTime-time())/(60*60*24)));
            //echo "$this->renewalNum $renewal";
            if( $this->expEmailSent && $this->ownerId==$gorumuser->id &&
                $gorumrecognised && $this->renewalNum < $renewal)
            {
                $tempRoll = $gorumroll;
                $tempRoll->list = $itemClassName;
                $tempRoll->method = "prolong_expiration";
                $tempRoll->id = $this->id;
                saveInFrom($tempRoll);
                $s.=" ".$tempRoll->generAnchor($lll["prolongExp"]);
            }
        }
        else
        {
            $s = $lll["N/A"];
        }
    }
    elseif (!$expiration && $attr=="expirationTime")
    {
        $s = $lll["N/A"];
    }
    elseif ($attr=="creationTime") 
    {
        $s=showTimestamp($this->{$attr});
    }
    elseif ($attr=="showpic") {
        if( $this->picture )
        {
            $picName = "$adAttDir/$this->id"."."."$this->picture";
            $f=@fopen($picName,"r");
            $supported=FALSE;
            if( $f )
            {
                if( defined("IMG_GIF") && function_exists("ImageTypes"))//van GD
                {
                    $checkBits = array("gif"=>IMG_GIF, "jpg"=>IMG_JPG, "png"=>IMG_PNG);
                    $supported = (ImageTypes() & $checkBits[$this->picture]);
                }    
                if( $supported ) 
                {
                    $thName = "$adAttDir/th_$this->id"."."."$this->picture";
                    $size = getimagesize( $thName );
                    $width = $size[0];
                    $height = $size[1];
                }
                else
                {
                    global $thumbnailWidth, $thumbnailHeight;
                    $thName = $picName;
                    $size = getimagesize( $picName );
                    $width = $size[0];
                    $height = $size[1];
                    if( $width>$thumbnailWidth || $height>$thumbnailHeight )
                    {
                        $ratio = $width/$thumbnailWidth;
                        if( $height/$ratio>$thumbnailHeight ) $ratio=$height/$thumbnailHeight;
                        $width = $width/$ratio;
                        $height = $height/$ratio;
                    }
                }
                $s="<a href='$picName' target='_blank'><img src='$thName' width='$width' height='$height' border='0'></a>";
            }
            else $s="<img src='$adAttDir/no.png'>";
        }
        else $s="<img src='$adAttDir/no.png'>";    
    }
    elseif ($attr=="shoppingCartLink" && $withShoppingCart) 
    {
        $tempRoll = new Roll;
        $tempRoll->list = $shoppingCartClassName;
        $tempRoll->method = "create";
        $tempRoll->item = $this->id;
        saveInFrom($tempRoll);
        $s=$tempRoll->generImageAnchor("i/add2cart.gif", $lll["addToChart"]);
    }
    elseif ($attr=="price") 
    {   
        global $currency;
        $s = sprintf ("$currency%01.2f", $this->price);
    }
    else // ha valtozo mezorol van szo
    {
        hasAdminRights( $isAdm );
        if( in_array("private", $item_typ["attributes"][$attr]) &&
            $this->keepPrivate && !$isAdm )
        {
            $s=$lll["privateField"];
        }
        elseif( in_array("text", $item_typ["attributes"][$attr]) ||
                in_array("textarea", $item_typ["attributes"][$attr]) )
        {
            if( in_array("badwords", $item_typ["attributes"][$attr]) )
            {
                if (in_array("html", $item_typ["attributes"][$attr])) {
                    $s=replaceBadWords($this->{$attr});
                }
                else {
                    $s=replaceBadWords(nl2br(htmlspecialchars($this->{$attr})));
                }    
            }
            else
            {
                if (in_array("html", $item_typ["attributes"][$attr])) {
                    $s=$this->{$attr};
                }    
                else {
                    $s=nl2br(htmlspecialchars($this->{$attr}));
                }    
            }
            if( isset($item_typ["attributes"][$attr]["format"]) )
            {
                // ha definialva van egy spec formatum, akkor alkallmazzuk:
                $s = sprintf( $item_typ["attributes"][$attr]["format"], $s );
            }
        }
        elseif( in_array("bool", $item_typ["attributes"][$attr]) )
        {
            $s = $this->{$attr} ? $lll["yes"] : $lll["no"];
        }
        elseif( in_array("selection", $item_typ["attributes"][$attr]) )
        {
            $helpindex = $item_typ["attributes"][$attr]["helpindex"];
            $s = $lll["col_$helpindex"."_".$this->{$attr}];
        }
        elseif( in_array("multipleselection", $item_typ["attributes"][$attr]) ||
                in_array("checkbox", $item_typ["attributes"][$attr]))
        {
            if(  $this->{$attr}!="" ) 
            {
                $helpindex = $item_typ["attributes"][$attr]["helpindex"];
                $first = TRUE;
                $vals = split(", *", $this->{$attr});
                foreach( $vals as $val )
                {
                    if( !$first ) $s.=", ";
                    else $first = FALSE;
                    $s.=$lll["col_$helpindex"."_".$val];
                    //TODO: ha az $s-ben 0 van, az valahogy nem jelenik meg a details pagen
                }
            }    
        }
        else
        {
            $s = Item::showListVal($attr);
        }
    }
    return $s;
}

function prolongExpiration()
{
    global $infoText, $lll, $whatHappened, $expiration, $renewal;
    
    load($this);    
    $this->hasObjectRights( $hasRight, Priv_modify, TRUE );
    if( $this->renewalNum < $renewal )
    {
        $this->expirationTime += 60*60*24*$expiration;
        $this->expEmailSent = FALSE;
        $this->renewalNum++;
        modify($this);
        $infoText = $lll["expirationProlonged"];
        if( $this->renewalNum==$renewal )$infoText.=$lll["lastRenewal"];
    }
    $whatHappened = "form_submitted";
}

function create($overrulePrivilege=FALSE)
{
    global $charLimit,$whatHappened,$infoText,$lll, $expiration;
    global $immediateAppear, $adminEmail, $itemClassName, $showSubmitAd;
    

    hasAdminRights($isAdm);
    if( !$showSubmitAd && !$isAdm ) handleError("Permission denied");
    $object_vars = get_object_vars($this);
    foreach( $object_vars as $attr=>$val )
    {
        if (!is_array($val) && strlen($val)>$charLimit) {
            $whatHappened = "invalid_form";
            $infoText = sprintf($lll["ad_limit_exc"],$charLimit,
                                strlen($val));
            return;        
        }
    }
    if( $immediateAppear )
    {
        $exp = isset($expiration) ? $expiration : 30; // installib miatt
        $this->expirationTime = time()+60*60*24*$exp; 
    }
    $this->activateVariableFields();
    initAttrsThatDontGetValueInTheForm($this);
    Item::create($overrulePrivilege);
    if( $whatHappened=="form_submitted" )
    {
        if( !$immediateAppear ) $infoText.="<br>".$lll["adScheduled"];
        $n = new Notification;
        $n->id = Notification_adCreated;
        $n->load();
        if( $n->active )
        {
            // mailt kuldunk rola az adminnak:
            $tempRoll = new Roll;
            $tempRoll->list = $itemClassName;
            $tempRoll->method = "showdetails";
            $tempRoll->rollid = $this->id; 
            $url = $tempRoll->makeUrl("mixed");
            $n->send( $adminEmail, $this->title, $url );
        }
        $this->storeAttachment();
    }
}

function modify( $whereFields="", $overrulePrivilege=FALSE )
{
    global $whatHappened, $charLimit, $infoText, $lll;
    global $immediateAppear, $allowModify, $adminEmail, $itemClassName;
    

    hasAdminRights($isAdm);
    if( !$isAdm && !$allowModify )
    {
        return;
    }
    $object_vars = get_object_vars($this);
    foreach( $object_vars as $attr=>$val )
    {
        if (!is_array($val) && strlen($val)>$charLimit) {
            $whatHappened = "invalid_form";
            $infoText = sprintf($lll["ad_limit_exc"],$charLimit,
                                strlen($val));
            return;        
        }
    }
    $this->activateVariableFields();
    initAttrsThatDontGetValueInTheForm($this);
    Item::modify($whereFields, $overrulePrivilege);
    if( $whatHappened=="form_submitted" )
    {
        if( !$immediateAppear ) $infoText.="<br>".$lll["adScheduled"];
        $n = new Notification;
        $n->id = Notification_adCreated;
        $n->load();
        if( $n->active )
        {
            // mailt kuldunk rola az adminnak:
            $tempRoll = new Roll;
            $tempRoll->list = $itemClassName;
            $tempRoll->method = "showdetails";
            $tempRoll->rollid = $this->id; 
            $url = $tempRoll->makeUrl("mixed");
            $n->send( $adminEmail, $this->title, $url );
        }
        $this->storeAttachment();
    }
}

function showDetails(&$s)
{
    global $gorumroll,$lll, $item_typ, $immediateAppear, $gorumuser;
    global $adAttDir, $thumbnailWidth, $thumbnailHeight, $itemClassName;
    global $xi, $expiration;
    
    // Az expiration time-nak csak akkor van ertelme, ha mar active:
    $this->id = $gorumroll->rollid;
    load($this);
    if( $gorumuser->id!=$this->ownerId && !$gorumuser->isAdm )
    {
        $this->clicked++;
        modify($this);
    }
    $this->activateVariableFields();
    if( !$immediateAppear )
    {
        hasAdminRights( $isAdm );
        if( $isAdm || $this->ownerId==$gorumuser->id )
        {
            $item_typ["attributes"]["active"][]="details";
        }    
        if( $expiration && $this->active )  
        {
            $item_typ["attributes"]["expirationTime"][]="details";
        }
    }
    
    $attrs=$item_typ["attributes"];
    $this->hasGeneralRights($rights);
    $attributeList = isset($item_typ["order"]) ? 
                     $item_typ["order"] : array_keys($item_typ["attributes"]);
    global $mainBoxWidth,$mainBoxPadding;
    if (!isset($mainBoxWidth)) $mainBoxWidth="100%";
    if (!isset($mainBoxPadding)) $mainBoxPadding="2";
    $s.=generBoxUp($mainBoxWidth,$mainBoxPadding);    

    $s1=showTools($this,$rights);
    $s.="<tr><th class='header' colspan='3'>";
    $s.="<table border='0' width='100%' cellpadding='0'".
        " cellspacing='0'><tr>\n";
    $s.="<th class='header'>";
    $s.=sprintf($lll["detail_info"],$lll["advertisement"]);
    $s.="</th>\n";
    $s.="<th class='headermethod' nowrap>$s1</th>\n";
    $s.="</tr></table>";
    $s.="</th></tr>\n";
    
    $supported=FALSE;
    if( $this->picture )
    {
        $picName = "$adAttDir/$this->id"."."."$this->picture";
        if( defined("IMG_GIF") && function_exists("ImageTypes"))//van GD
        {
            $checkBits = array("gif"=>IMG_GIF, "jpg"=>IMG_JPG, "png"=>IMG_PNG);
            $supported = (ImageTypes() & $checkBits[$this->picture]);
        }    
        if( $supported ) 
        {
            $thName = "$adAttDir/th_$this->id"."."."$this->picture";
            $size = getimagesize( $thName );
            $width = $size[0];
            $height = $size[1];
        }
        else
        {
            $thName = $picName;
            $size = getimagesize( $picName );
            $width = $size[0];
            $height = $size[1];
            if( $width>$thumbnailWidth || $height>$thumbnailHeight )
            {
                $ratio = $width/$thumbnailWidth;
                if( $height/$ratio>$thumbnailHeight ) $ratio=$height/$thumbnailHeight;
                $width = $width/$ratio;
                $height = $height/$ratio;
            }
        }
        $s.="<tr><td valign='top' align='left' rowspan='30' class='cell'>\n";
        $s.="<a href='$picName' target='_blank'>";
        $s.="<img src='$thName' border='0' width='$width' height='$height'></a>";
        $s.="</td>";
        $s.="</tr>\n";
    }    
    foreach( $attributeList as $attr ) 
    {
        $val = & $item_typ["attributes"][$attr];
        if ( !in_array("details",$val) ) continue;
        if( in_array("section",$val) )
        {
            $s.="<tr><th class='separator' colspan='2'>";
            $s.=$val["name"]; 
            $s.="</th></tr>\n";
            continue;
        }
        if (isset($lll[$itemClassName."_".$attr])) {
            $txt=$lll[$itemClassName."_".$attr];
        }
        else $txt=$lll[$attr];
        $s.="<tr><td class='colheader' width='30%'>";
        $s.=$txt;
        $s.="</td>\n";
        $s.="<td class='cell' width='70%'>";
        $valTxt=$this->showListVal($attr,$rights);
        $s.=$valTxt ? $valTxt : "&nbsp;";
        $s.="</td></tr>\n";
    }
    /*
    if( $supported )
    {
        $s.="</table>";
    }
    */
    $s.=generBoxDown();
    //$s.=generBoxDown(); ????
    
    $s.=vertSpacer();
    $s.="<center>\n";
    $s.="<table border='0' cellpadding='5' cellspacing='0'><tr>";
    $s.="<td class='linkbutton'>";
    $tempRoll = $gorumroll;
    $tempRoll->list = "response";
    $tempRoll->method = "create_form";   
    $tempRoll->rollid = $this->id;   
    saveInFrom($tempRoll);
    $link=$tempRoll->generAnchor($lll["new_resp"], "item");
    $link=eregi_replace("<a","<a target='_blank'",$link);
    $s.=$link;
    $s.="</td>\n";
    $s.="<td><img src='$xi/b.gif' width='50' height='1'></td>\n";
    $s.="<td class='linkbutton'>";
    $tempRoll = $gorumroll;
    $tempRoll->list = "friendmail";
    $tempRoll->method = "create_form";   
    $tempRoll->rollid = $this->id;   
    saveInFrom($tempRoll);
    $link=$tempRoll->generAnchor($lll["new_frie"], "item");
    $link=eregi_replace("<a","<a target='_blank'",$link);
    $s.=$link;
    $s.="</td>\n";
    $s.="</tr></table>\n";
    $s.="</center>\n";

}

function getListSelect()
{
    global $gorumroll, $item_typ, $gorumuser, $applName,$HTTP_POST_VARS;
    global $itemClassName, $categoryClassName, $searchClassName, $expiration;
    
    if (isset($this->cid) && $this->cid) 
    {
        $this->activateVariableFields();
    }
    else
    {
        $item_typ["attributes"]["creationtime"][]="list";
        if ($expiration && $gorumroll->list!=$itemClassName."_inactive")
        {
            $item_typ["attributes"]["expirationTime"][]="list";
        }
    }
    if ($gorumroll->list==$itemClassName."_search") {
        $search = new $searchClassName;
        $search->id=$gorumuser->id;
        load($search);
        $select = "SELECT ".getAllColumns($item_typ, "n").
                  "c.wholeName AS cName ".
                  "FROM $applName"."_$itemClassName AS n, ".
                  $applName."_$categoryClassName AS c ".
                  "WHERE c.id=n.cid AND n.active='1'";
        if( $search->query ) $select.=" AND $search->query";
        // Ha nem advanced search-rol van szo, akkor az eredmeny tobb
        // kategoriabeli hirdetest is tartalmazhat -> a kategorianevet
        // is fel kell tunteni a listaban:
        if( !isset($HTTP_POST_VARS["relationBetweenFields"]) )
        {
            $item_typ["attributes"]["cName"][]="list";
        }    
        //echo "<p>$search->query<p>";
        return $select;
    }
    else 
    {
        return Item::getListSelect();
    }    
}

function createForm(&$s)
{
    global $lll, $infoText, $showSubmitAd;

    $this->hasObjectRights($hasRight, Priv_create, FALSE);
    hasAdminRights($isAdm);
    if( !$showSubmitAd && !$isAdm ) handleError("Permission denied");
    $s = "";
    if( !$hasRight )
    {
        $infoText = $lll["registerOrLoginToSubmit"];
    }
    else
    {
        $this->activateVariableFields();
        return Item::createForm($s);
    }    
}    

function modifyForm(&$s)
{
    global $gorumroll, $lll;
    
    if( !$gorumroll->invalid )
    {    
        $ret = $this->load();
        if( $ret )
        {
            $txt = $lll["not_found_in_db"];
            handleError($txt);
        }
    } 
    else $gorumroll->invalid = FALSE;
    $this->hasObjectRights($hasRight, Priv_modify, TRUE);
    $this->activateVariableFields();//csak emiatt kellett feluldefinialn
    $this->generForm($s);
}

function activateVariableFields()
{
    global $item_typ, $variableFieldsNum, $lll, $itemClassName;
    global $gorumroll, $expiration;
    
    hasAdminRights($isAdm);
    $v = new VarFields;
    $v->id = $this->cid;
    $v->load();
    if( $expiration && $v->showExpirationTime ) $item_typ["attributes"]["expirationTime"][]="list";
    if( !$expiration ) $this->removeFromTypeInfo( "expirationTime", "details" );
    if( $v->showCreationTime ) $item_typ["attributes"]["creationtime"][]="list";
    $foundOneFieldThatCanBePrivate = FALSE;
    for( $i=0; $i<$variableFieldsNum; $i++ )
    {
        if( ($isAdm && $v->{"active_$i"}) || (!$v->{"hidden_$i"} && $v->{"active_$i"}) )
        {
            // form invisible kikapcs:
            unset($item_typ["attributes"]["col_$i"][0]); 
            $lll[$itemClassName."_col_$i"]=$v->{"name_$i"};
            if( $v->{"mandatory_$i"} ) 
            {
                $item_typ["attributes"]["col_$i"][]="mandatory";
                $item_typ["attributes"]["col_$i"]["min"]="1";
            }    
            if( $v->{"list_$i"} ) $item_typ["attributes"]["col_$i"][]="list";
            if( $v->{"searchable_$i"} ) $item_typ["attributes"]["col_$i"][]="searchable";
            if( $v->{"badwords_$i"} ) $item_typ["attributes"]["col_$i"][]="badwords";
            if( $v->{"allowHtml_$i"} ) $item_typ["attributes"]["col_$i"][]="html";
            // Ha van legalabb egy olyan field, ami privatta teheto,
            // akkor lathatova tesszuk a formban a keepPrivate
            // attributumot:
            if( $v->{"private_$i"} )
            {
                $foundOneFieldThatCanBePrivate=TRUE;
                $item_typ["attributes"]["col_$i"][]="private";
                if( isset($lll["private_field"]) && 
                    strstr($gorumroll->method, "_form") )
                {
                    $lll[$itemClassName."_col_$i"].="<span class='privateNote'> $lll[private_field]</span>";
                }
            }
            $item_typ["attributes"]["col_$i"][]="details";
            switch( $v->{"type_$i"} )
            {
            case varfields_text:
                $item_typ["attributes"]["col_$i"][]="text";
                $item_typ["attributes"]["col_$i"]["default"]=$v->{"default_$i"};
                if( $v->{"format_$i"} ) 
                {
                    $item_typ["attributes"]["col_$i"]["format"]=$v->{"format_$i"};
                }    
                break;
            case varfields_textarea:
                $item_typ["attributes"]["col_$i"][]="textarea";
                $item_typ["attributes"]["col_$i"]["default"]=$v->{"default_$i"};
                $item_typ["attributes"]["col_$i"]["rows"]=10;
                $item_typ["attributes"]["col_$i"]["cols"]=50;
                if( $v->{"innewline_$i"} ) $item_typ["attributes"]["col_$i"][]="in new line";
                break;
            case varfields_bool:
                $item_typ["attributes"]["col_$i"][]="bool";
                $item_typ["attributes"]["col_$i"]["default"]=$v->{"default_$i"};
                break;
            case varfields_selection:
                $item_typ["attributes"]["col_$i"][]="selection";
                $item_typ["attributes"]["col_$i"]["helpindex"]="$i";
                $vals = split(", *", $v->{"values_$i"});
                $valNum = count($vals);
                for( $j=0; $j<$valNum; $j++ )
                {
                    $item_typ["attributes"]["col_$i"]["values"][]=$j;
                    $lll["col_$i"."_$j"]=$vals[$j];
                    if( $vals[$j]==$v->{"default_$i"} )
                        $item_typ["attributes"]["col_$i"]["default"]="$j";
                }
                break;
            case varfields_multipleselection:
                $item_typ["attributes"]["col_$i"][]="multipleselection";
                $item_typ["attributes"]["col_$i"]["helpindex"]="$i";
                $vals = split(", *", $v->{"values_$i"});
                $defs = split(", *", $v->{"default_$i"});
                $valNum = count($vals);
                $item_typ["attributes"]["col_$i"]["size"]=min(10, $valNum);
                $item_typ["attributes"]["col_$i"]["default"]="";
                $first=TRUE;
                $item_typ["attributes"]["col_$i"]["values"]=array();
                for( $j=0; $j<$valNum; $j++ )
                {
                    $item_typ["attributes"]["col_$i"]["values"][]=$j;
                    $lll["col_$i"."_$j"]=$vals[$j];
                    if( in_array($vals[$j], $defs) )
                    {
                        if( !$first ) $item_typ["attributes"]["col_$i"]["default"].=",";
                        else $first=FALSE;
                        $item_typ["attributes"]["col_$i"]["default"].=$j;
                    }    
                }
                break;
            case varfields_checkbox:
                $item_typ["attributes"]["col_$i"][]="checkbox";
                $item_typ["attributes"]["col_$i"]["helpindex"]="$i";
                $vals = split(", *", $v->{"values_$i"});
                $defs = split(", *", $v->{"default_$i"});
                $valNum = count($vals);
                $item_typ["attributes"]["col_$i"]["cols"]=1;
                $item_typ["attributes"]["col_$i"]["default"]="";
                $first=TRUE;
                $item_typ["attributes"]["col_$i"]["values"]=array();
                for( $j=0; $j<$valNum; $j++ )
                {
                    $item_typ["attributes"]["col_$i"]["values"][]=$j;
                    $lll["col_$i"."_$j"]=$vals[$j];
                    if( in_array($vals[$j], $defs) )
                    {
                        if( !$first ) $item_typ["attributes"]["col_$i"]["default"].=",";
                        else $first=FALSE;
                        $item_typ["attributes"]["col_$i"]["default"].=$j;
                    }    
                }
                break;
            case varfields_separator:
                $item_typ["attributes"]["col_$i"][]="section";
                $item_typ["attributes"]["col_$i"][]="details";
                $item_typ["attributes"]["col_$i"]["name"]=$v->{"name_$i"};
                $lll["col_$i"] = $v->{"name_$i"};
                break;
            default:
                break;    
            }
            
        }
    }    
    if( !$foundOneFieldThatCanBePrivate )
    {
        $item_typ["attributes"]["keepPrivate"][]="form invisible";
        // Ez azert kell, mert a keepPrivate eredetileg visible volt,
        // ezert a processMethod inicializalta FALSE-ra. Egy modify 
        // soran viszont ez mar ugy fog tunni, mint egy invisible attr
        // modositasi kiserlete es az baj.
        unset($this->keepPrivate);
    }

    global $showPicInList, $withShoppingCart;
    if ($showPicInList) {
        $item_typ["attributes"]["showpic"][]="list";
        $item_typ["attributes"]["showpic"][]="no column";
        $item_typ["attributes"]["showpic"][]="rowspan";
        $item_typ["attributes"]["showpic"][]="centered";
        // csak hogy a getDefault ne adjon hibat:
        $item_typ["attributes"]["showpic"]["type"]="VARCHAR";
    }
    if ($withShoppingCart && !$isAdm) {
        $item_typ["attributes"]["shoppingCartLink"][]="list";
        $item_typ["attributes"]["shoppingCartLink"][]="no column";
        $item_typ["attributes"]["shoppingCartLink"][]="rowspan";
        $item_typ["attributes"]["shoppingCartLink"][]="centered";
        $item_typ["attributes"]["shoppingCartLink"][]="form invisible";
        $item_typ["attributes"]["shoppingCartLink"][]="details";
        // csak hogy a getDefault ne adjon hibat:
        $item_typ["attributes"]["shoppingCartLink"]["type"]="VARCHAR";
    }
    
}

function valid()
{
    global $lll;
    global $infoText, $whatHappened;
    global $HTTP_POST_FILES;
    global $maxPicSize,$maxPicWidth,$maxPicHeight;
    
    if (!isset($HTTP_POST_FILES["picture"]["name"]) ||
        $HTTP_POST_FILES["picture"]["name"]=="")
    {
        return Item::valid();
    }
    if (isset($HTTP_POST_FILES["picture"]["name"]) &&
        strstr($HTTP_POST_FILES["picture"]["name"]," "))
    {
        $whatHappened = "invalid_form";
        $infoText = $lll["spacenoatt"];
        return ok;
    }
    if ($HTTP_POST_FILES["picture"]["size"]==0) {
        $infoText=$lll["picFileSizeNull"];
        $whatHappened = "invalid_form";
        return ok;
    }
    if ($HTTP_POST_FILES["picture"]["tmp_name"]=="none") {
        $infoText=$lll["picFileSizeToLarge1"];
        $whatHappened = "invalid_form";
        return ok;
    }
    if ($HTTP_POST_FILES["picture"]["size"]>$maxPicSize) {
        $infoText=sprintf($lll["picFileSizeToLarge2"], $maxPicSize);
        $whatHappened = "invalid_form";
        return ok;
    }
    if (!is_uploaded_file( //ONLY from php 4.02 !!!
            $HTTP_POST_FILES["picture"]["tmp_name"]))
    {
        handleError("Possible attack");
    }
    $fname=$HTTP_POST_FILES["picture"]["tmp_name"];
    $size = getimagesize( $fname );
    if (!$size) {
        $infoText=$lll["notValidImageFile"];
        $whatHappened = "invalid_form";
        return ok;
    }
    $type = $size[2]; // az image tipus, 1=>GIF, 2=>JPG, 3=>PNG
    $extensions = array("", "gif", "jpg", "png");
    if (!isset($extensions[$type]) ) {
        $infoText=$lll["notValidImageFile"];
        $whatHappened = "invalid_form";
        return ok;
    }
    if( $size[0]>$maxPicWidth || $size[1]>$maxPicHeight )
    {
        $infoText=sprintf($lll["picFileDimensionToLarge"], $maxPicWidth, $maxPicHeight);
        $whatHappened = "invalid_form";
        return ok;
    }
    return Item::valid();
}

function storeAttachment()
{
    global $HTTP_POST_FILES;
    global $whatHappened, $lll;
    global $adAttDir, $applName, $itemClassName;
    global $maxPicSize,$maxPicWidth,$maxPicHeight;
    global $thumbnailWidth, $thumbnailHeight;

    if (!isset($HTTP_POST_FILES["picture"]["name"]) ||
        $HTTP_POST_FILES["picture"]["name"]=="")
    {
        return ok;
    }
    $fname=$HTTP_POST_FILES["picture"]["tmp_name"];
    $f=fopen($fname,"r");
    if (!$f) {
        $attErrTxt = "Error opening attached file!";
        return nok;
    }
    // mas fg-eket kell hivni az image tipusnak megfeleloen:
    $create_fg = array("", "ImageCreateFromGIF", "ImageCreateFromJPEG", 
                           "ImageCreateFromPNG");
    $save_fg = array("", "ImageGIF", "ImageJPEG", "ImagePNG");
    $extensions = array("", "gif", "jpg", "png");
    $size = getimagesize( $fname );
    $width = $size[0];
    $height = $size[1];
    $type = $size[2]; // az image tipus, 1=>GIF, 2=>JPG, 3=>PNG
    $supported=FALSE;
    if( defined("IMG_GIF") && function_exists("ImageTypes"))//van GD
    {
        $checkBits = array(0, IMG_GIF, IMG_JPG, IMG_PNG);
        $supported = isset($checkBits[$type]) && ((ImageTypes() & $checkBits[$type]));
    }    
    // ha az adott image tipus supportalva van:
    if( $supported ) 
    {
        if( $width>$thumbnailWidth || $height>$thumbnailHeight )
        {
            $ratio = $width/$thumbnailWidth;
            if( $height/$ratio>$thumbnailHeight ) $ratio=$height/$thumbnailHeight;
            $newWidth = $width/$ratio;
            $newHeight = $height/$ratio;
        }
        else
        {
            $newWidth = $width;
            $newHeight = $height;
        }
        $src_im = $create_fg[$type]($fname);
        $dst_im = ImageCreate ($newWidth, $newHeight);
        imagecopyresized ($dst_im, $src_im, 0, 0, 0, 0, $newWidth, $newHeight, $width, $height);
    }
    $file = fread($f,$HTTP_POST_FILES["picture"]["size"]);
    $ext = $extensions[$type];
    $foname = "$adAttDir/$this->id".".".$ext;
    $th_foname = "$adAttDir/th_$this->id".".".$ext;
    $fo = fopen($foname,"w");
    //TODO: error handle
    fwrite( $fo,$file);
    fclose( $fo );
    if( $supported ) $save_fg[$type]( $dst_im, $th_foname );
    // A picture-ben csak azt taroljuk el, hogy mi a kiterjesztes:
    $query = "UPDATE $applName"."_$itemClassName SET picture='$ext'".
             " WHERE id=$this->id";
    executeQuery( $query );
    $HTTP_POST_FILES["picture"]["name"]="";
    return ok;
}

} // class


function checkExpiration()
{
    global $expiration, $expNoticeBefore, $lll;
    global $applName, $itemClassName, $userClassName,$categoryClassName;
    
    if( !$expiration )
    {
        return;
    }
    $timeBeforeExp = 60*60*24*$expNoticeBefore + time();
    $query = "SELECT a.id, title, c.name as cName, a.expirationTime, email ".
             "FROM $applName"."_$itemClassName AS a, $applName"."_$userClassName AS u, ".
             $applName."_$categoryClassName AS c WHERE ".
             "a.expEmailSent='0' AND a.ownerId=u.id AND a.active='1' AND ".
             "$timeBeforeExp>a.expirationTime AND a.cid=c.id";
    $ads = new $itemClassName;
    loadObjectsSql($ads, $query, $ads);
    $n = new Notification;
    $n->id = Notification_adExpired;
    $n->load();
    foreach( $ads as $ad )
    {
        if( $n->active )
        {
            $n->send( $ad->email,
                  (int)(round(($ad->expirationTime-time())/(60*60*24))),
                  $ad->cName, $ad->title );
        }
        $adMod = new $itemClassName;
        $adMod->id = $ad->id;
        $adMod->expEmailSent=TRUE;
        modify($adMod);
        break;
    }             
}

function deleteExpiredAds()
{
    global $expiration, $lll, $applName;
    global $itemClassName, $userClassName,$categoryClassName;
    if( !$expiration )
    {
        return;
    }
    $exp = 60*60*24*$expiration;
    $query = "SELECT a.id, title, c.name as cName, a.expirationTime, email ".
             "FROM $applName"."_$itemClassName AS a, $applName"."_$userClassName AS u, ".
             $applName."_$categoryClassName AS c WHERE ".
             "a.ownerId=u.id AND a.active='1' AND ".
             time().">a.expirationTime AND a.cid=c.id";
    $ads = new $itemClassName;
    loadObjectsSql($ads, $query, $ads);
    $n = new Notification;
    $n->id = Notification_adDeleted;
    $n->load();
    foreach( $ads as $ad )
    {
        if( $n->active )
        {
            $n->send( $ad->email, $ad->cName, $ad->title );
        }
        // azert TRUE-val,  mert nem akarjuk, hogy a delete is kuldjon 
        // egy mailt:
        $ad->delete("",TRUE,TRUE);
    }             
}

?>
