<?php
function generMultipleSelection($name, $label, $explText, $listNames, 
                                $listValues, $selected, $listSize, 
                                $tdCl="", $spanCl="",$withLabel=TRUE)
{
    global $lll,$list2Colors;
    global $hasJsReload, $jsReloader, $jsElementCount;
    $s="";
    $labelCl="label";
    if (isset($list2Colors) && $withLabel) {
        if ($list2Colors && $tdCl=="cell") {
            $tdCl="cell2";
            $labelCl="label2";
        }
        $list2Colors = ($list2Colors + 1) % 2;
    }    
    if ($withLabel) {
        $s.="<tr";
        if ($tdCl!="") $s.=" class='$tdCl'";
        $s.="><td";
        if ($tdCl!="") $s.=" class='$labelCl'";
        $s.=">";
        if ($spanCl!="") $s.="<span class='$spanCl'>$label</span>";
        else $s.=$label;
        if($explText) $s.=generExplanation( $label, $explText );        
        $s.="</td><td>\n";
    }
    $s.="<select name='$name"."[]' size='$listSize' multiple>\n";
    $length = count($listValues);
    if( $selected=="" ) $selected=array();
    elseif( !is_array($selected) ) $selected=split(", *", $selected);
    if( $length )
    {
        foreach( $listValues as $key=>$value )
        {
            $s.="<option value='".$value."'";
            if( in_array($value, $selected) ) $s.=" selected";
            $s.=">".htmlspecialchars($listNames[$key])."</option>\n";
        }
    }
    else $s.="<option value='0'>".$lll["emptyList"]."</option>\n";    
    $s.="</select>\n";
    if ($withLabel) {
        $s.="</td></tr>\n";
    }
    
    if( $hasJsReload )
    {
        $jsReloader.="
        var firstT=true;
        var t='';
        for( var j=0; j < $length; j++ )
        {
            if( elements[$jsElementCount].options[j].selected )
            {
                if( !firstT ) t = t + ',';
                else firstT = false;
                t = t + elements[$jsElementCount].options[j].value;
            }
        }    
        urlPlus = urlPlus + '$name=' + t + '&';
        ";
    }
    $jsElementCount++;
    
    return $s;
}

function generCheckbox($name, $label, $explText, $listNames, 
                        $listValues, $selected, $cols, 
                        $tdCl="", $spanCl="",$withLabel=TRUE, $onClick="",
                        $afterField="",$vert=FALSE)
{
    global $lll, $list2Colors;
    global $hasJsReload, $jsReloader, $jsElementCount;
    
    $s="";
    $labelCl="label";
    if (isset($list2Colors) && $withLabel) {
        if ($list2Colors && $tdCl=="cell") {
            $tdCl="cell2";
            $labelCl="label2";
        }
        $list2Colors = ($list2Colors + 1) % 2;
    }    
    if ($withLabel) {
        $s.="<tr";
        if ($tdCl!="") $s.=" class='$tdCl'";
        $s.="><td";
        if ($tdCl!="") $s.=" class='$labelCl'";
        $s.=">";
        if ($spanCl!="") $s.="<span class='$spanCl'>$label</span>";
        else $s.=$label;
        if($explText) $s.=generExplanation( $label, $explText );        
        $s.="</td><td>\n";
    }
    $s.="<table border='0' colspan='0' rowspan='0'><tr><td class='$tdCl'>\n";
    $length = count($listValues);
    if( $selected=="" ) $selected=array();
    elseif( !is_array($selected) ) $selected=split(", *", $selected);
    
    if( $hasJsReload )
    {
        $top = $jsElementCount+$length;
        $jsReloader.="
        var firstT=true;
        var t='';
        for( var j=$jsElementCount; j < $top; j++ )
        {
            if( elements[j].checked )
            {
                if( !firstT ) t = t + ',';
                else firstT = false;
                t = t + elements[j].value;
            }
        }    
        urlPlus = urlPlus + '$name=' + t + '&';
        ";
    }
    
    if ($vert) {//vertical
        $rows=ceil($length/$cols);
        $ind1=0;
        $ind2=0;
        $aind=0;
        $aindH=0;
        for( $i=0; $i<$rows; $i++ ) {
            $s.="<tr>";
            for($j=0;$j<$cols;$j++) {
                if( !isset($listValues[$ind2]) ) break;

                $s.="<td class='$tdCl'>";

                $s.="<input type='checkbox' name='$name".
                    "[$ind2]' value='".$listValues[$ind2]."'";
                if( in_array($listValues[$ind2], $selected) ) $s.=" checked";
                if( $onClick ) $s.=" onClick='$onClick'";
                $s.=">".$listNames[$ind2];
                $jsElementCount++;
                
                $s.="</td>\n";
                $ind2+=$rows;
            }
            $s.="</tr>\n";
            $ind1++;
            $ind2=$ind1;
        }

    }
    else {//horizontal
        for( $i=0; $i<$length/$cols; $i++ )
        {
            $s.="<tr>";
            for( $j=$i*$cols; $j<($i+1)*$cols; $j++ )
            {
                if( !isset($listValues[$j]) ) break(2);
                $s.="<td class='$tdCl'>";
                $s.="<input type='checkbox' name='$name".
                    "[]' value='".$listValues[$j]."'";
                if( in_array($listValues[$j], $selected) ) $s.=" checked";
                if( $onClick ) $s.=" onClick='$onClick()'";
                $s.=">".$listNames[$j];
                $jsElementCount++;
                $s.="</td>\n";            
            }
            $s.="</tr>\n";
        }
    }
    if ($afterField) {
        $s.="<tr>";
        $s.="<td colspan='$cols' class='$tdCl'>$afterField</td>";
        $s.="</tr>";
    }
    $s.="</table>\n";
    if ($withLabel) {
        $s.="</td></tr>\n";
    }
    return $s;
}
?>
