<?php
function zmail3($letters,$mailman)
{
    global $zmailErrStr,$zmailSR;
    global $HTTP_SERVER_VARS;
    global $rcptErrArr;

    $zmailErrStr="";
    $zmailSR="";
    $eol="\r\n";
    //socket open
    $socket = @fsockopen($mailman->host,$mailman->port, $errno, $errstr);
    if (!$socket) {
        $zmailErrStr="fsockopen failed with parameters host:$mailman->host, ".
                     "port: $mailman->port, errno: $errno, errstr: $errstr";
        $retCode=1;
        return $retCode;
    }
    //socket_set_blocking($socket,TRUE);
    $ret=smtpSocketParse($socket,"socket open","220");
    if ($ret) {
        $retCode=2;
        return $retCode;
    }

    //HELO
    //a $HTTP_SERVER_VARS["HTTP_HOST"] tartalmazhat :80 -at
    $client=$mailman->client;
    if ($client=="" && isset($HTTP_SERVER_VARS["HTTP_HOST"]) &&
        $HTTP_SERVER_VARS["HTTP_HOST"])
    {
        $client=$HTTP_SERVER_VARS["HTTP_HOST"];
        if (strstr($client,":")) {
            $a=explode(":",$client);
            $client=$a[0];
        }
    }
    if ($client=="" && isset($HTTP_SERVER_VARS["SERVER_NAME"]) &&
        $HTTP_SERVER_VARS["SERVER_NAME"])
    {
        $client=$HTTP_SERVER_VARS["SERVER_NAME"];
        if (strstr($client,":")) {
            $a=explode(":",$client);
            $client=$a[0];
        }
    }
    if ($client=="") $client="localhost";
    global $smtpClient;
    if (isset($smtpClient)) $client=$smtpClient;


    $smtpUserName=$mailman->smtpUser;
    $smtpPassword=$mailman->smtpPass;
    if ($smtpUserName && $smtpPassword) {
        fputs($socket,"EHLO $client$eol");
        $ret=smtpSocketParse($socket,"EHLO","250");
        if ($ret) {
            $retCode=3;
            return $retCode;
        }
        fputs($socket,"AUTH LOGIN$eol");
        $ret=smtpSocketParse($socket,"AUTH LOGIN","334");
        if ($ret) {
            $retCode=8;
            return $retCode;
        }
        fputs($socket,base64_encode($smtpUserName).$eol);
        $ret=smtpSocketParse($socket,"SMTP username","334");
        if ($ret) {
            $retCode=9;
            return $retCode;
        }
        fputs($socket,base64_encode($smtpPassword).$eol);
        $ret=smtpSocketParse($socket,"SMTP password","235");
        if ($ret) {
            $retCode=10;
            return $retCode;
        }
    }
    else {
        fputs($socket,"HELO $client$eol");
        $ret=smtpSocketParse($socket,"HELO","250");
        if ($ret) {
            $retCode=3;
            return $retCode;
        }
    }    
    if (!is_array($letters)) $letters = array($letters);
    foreach($letters as $letter) {
        //MAIL
        fputs($socket,"MAIL from: $letter->from$eol");
        $ret=smtpSocketParse($socket,"MAIL","250");
        if ($ret) {
            $retCode=4;
            return $retCode;
        }    
        //RCPT
        if (is_array($letter->to)) {
            foreach($letter->to as $t) {
                fputs($socket,"RCPT TO: <$t>$eol");
                $ret=smtpSocketParse($socket,"RCPT TO","250","251");
                if ($ret) {
                    $rcptErrArr[]=$t;
                }
                else $rcptOk=1;
            }
        }
        else {
            fputs($socket,"RCPT TO: <$letter->to>$eol");
            $ret=smtpSocketParse($socket,"RCPT TO","250","251");
            if ($ret) {
                $rcptErrArr[]=$letter->to;
            }
            else $rcptOk=1;
        }
        //RCPT - CC
        if ($letter->vcc && is_array($letter->vcc)) {
            foreach($letter->vcc as $cc) {
                fputs($socket,"RCPT TO: <$cc>$eol");
                $ret=smtpSocketParse($socket,"RCPT TO","250","251");
                if ($ret) {
                    $rcptErrArr[]=$cc;
                }
                else $rcptOk=1;
            }
        }
        if ($letter->vcc && is_string($letter->vcc)) {
            fputs($socket,"RCPT TO: <$letter->vcc>$eol");
            $ret=smtpSocketParse($socket,"RCPT TO","250","251");
            if ($ret) {
                $rcptErrArr[]=$letter->vcc;
            }
            else $rcptOk=1;
        }
        if (!isset($rcptOk)) {
            $zmailErrStr="The server response to the RCPT request".
                         " was not 250 or 251.";
            return 5;
        }
        //DATA
        fputs($socket,"DATA$eol");    
        $ret=smtpSocketParse($socket,"DATA","354");
        if ($ret) {
            $retCode=6;
            return $retCode;
        }    
        //head
        fputs($socket,"Subject: $letter->subject$eol");
        if ($letter->vfrom) fputs($socket,"From: $letter->vfrom$eol");    
        if ($letter->retpath) fputs($socket,"Return-Path: $letter->retpath$eol");    
        if ($letter->repto) fputs($socket,"Reply-to: $letter->repto$eol");    
        if ($letter->vto) fputs($socket,"To: $letter->vto$eol");    
        else {
            if (is_array($letter->to)) {
                foreach($letter->to as $t) {
                    fputs($socket,"To: $t$eol");    
                }
            }
            else fputs($socket,"To: $letter->to$eol");    
        }
        if ($letter->vcc && is_array($letter->vcc)) {
            foreach($letter->vcc as $cc) {
                fputs($socket,"Cc: $cc$eol");
            }
        }
        if ($letter->vcc && is_string($letter->vcc)) {
            fputs($socket,"Cc: $letter->vcc$eol");
        }
        if ($letter->vdate) fputs($socket,"Date: $letter->vdate$eol");    
        if ($letter->mid) fputs($socket,"Message-ID: <$letter->mid>$eol");    
        if ($letter->addhead) fputs($socket,"$letter->addhead");

        //body
        $body=chop($letter->body);
        //change \n to \r\n
        $body=preg_replace("/([^\r])(\n)/","\\1\r\n",$body);
        $body=preg_replace("/([^\r])(\n)/","\\1\r\n",$body);
        $body=preg_replace("/^\n/","\r\n",$body);
        
        $body=str_replace("\n.","\n..",$body);
        $bs="";
        if ($letter->html) {
            $bs.="MIME-Version: 1.0$eol";
            $boundary = uniqid("mailgust");
            $bs.="Content-Type: multipart/alternative;".
                          " boundary=\"$boundary\"$eol$eol";
            //plain
            $bs.="--$boundary$eol";
            $bs.="Content-Type: text/plain;$eol";
            $bs.="Content-Transfer-Encoding: 8bit$eol$eol";
            //$bs.="Content-Transfer-Encoding: base64$eol$eol";
            //$bod=chunk_split(base64_encode(strip_tags($body)));
            $bod=strip_tags($body);
            $bod=chop($bod);
            $bod=str_replace("\n.","\n..",$bod);
            $bs.="$eol$bod$eol";
            //html
            $bs.="--$boundary$eol";
            $bs.="Content-Type: text/html;$eol";
            $bs.="Content-Transfer-Encoding: 8bit$eol$eol";
            //$bs.="Content-Transfer-Encoding: base64$eol$eol";
            //$bod=chunk_split(base64_encode($body));
            $bod=$body;
            $bs.="$eol$bod$eol";
            $bs.="--$boundary--$eol";
        }
        else $bs.="$body$eol";//plain mail
        if ($letter->att) {
            $as="";
            $boundary = uniqid("mailgust");
            $as.="MIME-Version: 1.0$eol";
            $as.="Content-Type: multipart/mixed;".
                          " boundary=\"$boundary\"$eol$eol";
            $as.="--$boundary$eol";
            $as.=$bs;
            //plain
            foreach($letter->att as $a) {
                $as.="--$boundary$eol";
                $as.="Content-Type: $a[mime];".
                     " name=\"$a[fname]\"$eol";
                $as.="Content-Transfer-Encoding: base64$eol";
                $as.="Content-Disposition: attachment;".
                     " filename=\"$a[fname]\"$eol$eol";
                set_magic_quotes_runtime(0);
                $as.=chunk_split(base64_encode($a["file"]));
                //var_dump($a);
                //echo "<br><br>";
            }
            $as.="--$boundary--$eol";
            //echo nl2br(htmlspecialchars($as));

            fputs($socket,$as);
        }
        else fputs($socket,$bs);

        fputs($socket,".$eol");

        $ret=smtpSocketParse($socket,"message","250");
        if ($ret) {
            $retCode=7;
            return $retCode;
        }    
    }//End send letters

    //fputs($socket, "RSET$eol"); 
    fputs($socket, "QUIT$eol");

    while(!feof($socket)) $zmailSR.=fgets($socket,4096);
    
    return 0;
}

function zmail2($from,$to,$subject,$body,$vfrom="",$vto="",$vcc="",$vdate="",$host="localhost",$port="25",$client="")
{
    global $zmailErrStr,$zmailSR;
    global $HTTP_SERVER_VARS;
    global $rcptErrArr;
    $zmailErrStr="";
    $zmailSR="";
    $eol="\r\n";
    //socket open
    $socket = fsockopen($host,$port, $errno, $errstr);
    if (!$socket) {
        $zmailErrStr="fsockopen failed with parameters host:$host, ".
                     "port: $port, errno: $errno, errstr: $errstr";
        return 1;
    }
    //socket_set_blocking($socket,TRUE);
    $s=fgets($socket, 4096);
    $zmailSR.=$s;
    $repCode=substr($s,0,3);
    if ($repCode!="220") {
        $zmailErrStr="The server response was not 220, mail server is".
                     " unavailable.";
        return 2;
    }
    //HELO
    if ($client=="" && isset($HTTP_SERVER_VARS["HTTP_HOST"]) &&
        $HTTP_SERVER_VARS["HTTP_HOST"])
    {
        $client=$HTTP_SERVER_VARS["HTTP_HOST"];
    }
    if ($client=="" && isset($HTTP_SERVER_VARS["SERVER_NAME"]) &&
        $HTTP_SERVER_VARS["SERVER_NAME"])
    {
        $client=$HTTP_SERVER_VARS["SERVER_NAME"];
    }
    if ($client=="") $client="zorum";

    fputs($socket,"HELO $client$eol");
    $s=fgets($socket, 4096);
    $zmailSR.=$s;
    $repCode=substr($s,0,3);
    if ($repCode!="250") {
        $zmailErrStr="The server response to the HELO request was not".
                     " 250.";
        return 3;
    }
    $j=0;
    foreach($to as $t) {
        $j++;
        //MAIL
        fputs($socket,"MAIL from: $from$eol");
        $s=fgets($socket, 4096);
        $zmailSR.=$s;
        $repCode=substr($s,0,3);
        if ($repCode!="250") {
            $zmailErrStr="The server response to the MAIL request was".
                         " not 250.";
            return 4;
        }
        //RCPT
        fputs($socket,"RCPT TO: <$t>$eol");
        $s=fgets($socket, 4096);
        $zmailSR.=$s;
        $repCode=substr($s,0,3);
        if ($repCode!="250" && $repCode!="251") {
            $rcptErrArr[]=$t;
            $continue;
        }
        else $rcptOk=1;

        //DATA
        fputs($socket,"DATA$eol");    
        $s="";
        $s=fgets($socket, 4096);
        $zmailSR.=$s;
        $repCode=substr($s,0,3);
        if ($repCode!="354") {
            $zmailErrStr="The server response to the DATA request was not".
                         " 354.";
            return 6;
        }
        fputs($socket,"Subject: $subject$eol");
        if ($vfrom) fputs($socket,"From: $vfrom$eol");    
        if ($vto) fputs($socket,"To: $vto$eol");    
        if ($vcc && is_array($vcc)) {
            foreach($vcc as $cc) {
                fputs($socket,"Cc: $cc$eol");
            }
        }
        if ($vcc && is_string($vcc)) {
            fputs($socket,"Cc: $vcc$eol");
        }
        if ($vdate) fputs($socket,"Date: $vdate$eol");    

        $sendbody=str_replace("\n.","\n..",$body);
        $sendbody.=$j;
        fputs($socket,"$sendbody$eol");

        fputs($socket,".$eol");

        $s=fgets($socket, 4096);
        $zmailSR.=$s;
        $repCode=substr($s,0,3);
        if ($repCode!="250") {
            $zmailErrStr="The server response to the message was not".
                         " 250.";
            return 7;
        }
        //fputs($socket, "RSET$eol"); 
    }
    if (!isset($rcptOk)) {
        $zmailErrStr="The server response to the RCPT request".
                     " was not 250 or 251.";
        return 5;
    }
    fputs($socket, "QUIT$eol");

    while(!feof($socket)) $zmailSR.=fgets($socket,4096);
    
    return 0;
}
function smtpSocketParse($socket,$comm,$respOk,$respOk2="9999") 
{ 
    global $zmailErrStr,$zmailSR;
    $serverResponse="";
    while(substr($serverResponse,3,1) != ' ' ) { 
       if ( !( $serverResponse = fgets($socket, 256) ) ) { 
          return nok;
       } 
       $zmailSR.=$serverResponse;
    }
    $repCode=substr($serverResponse,0,3);
    if ($repCode!=$respOk || $repCode!=$respOk) { 
         $zmailErrStr="The server response to the $comm request".
                      " was not $respOk";
         if ($respOk2!="9999") $zmailErrStr.=" or $respOk2";
         return nok;    
    }
    return ok;
}
class Letter
{
    var $from;
    var $to;
    var $subject;
    var $html;
    var $att;
    var $vfrom;
    var $vto;
    var $vcc;
    var $vdate;
    var $mid;
    var $retpath;
    var $repto;
    var $addhead;
    function Letter($from,$to,$subject,$body,$html=0,$att=0,$vfrom="",$vto="",
                    $vcc="",$vdate="",$mid="",$retpath="",$repto="",$addhead="")
    {
        $this->from=$from;
        $this->to=$to;
        $this->subject=$subject;
        $this->body=$body;
        $this->html=$html;
        $this->att=$att;
        $this->vfrom=$vfrom;
        $this->vto=$vto;
        $this->vcc=$vcc;
        $this->vdate=$vdate;
        $this->mid=$mid;
        $this->retpath=$retpath;
        $this->repto=$repto;
        $this->addhead=$addhead;
    }
}
class MailMan
{
    var $host;
    var $port;
    var $client;
    var $smtpUser;
    var $smtpPass;
    function MailMan($host="localhost",$port="25",$client="",$smtpUser="",
                     $smtpPass="")
    {
        global $smtpUserName,$smtpPassword;
        $this->host=$host;
        $this->port=$port;
        $this->client=$client;
        $this->smtpUser=$smtpUser;
        $this->smtpPass=$smtpPass;
        if (isset($smtpUserName) && !$smtpUser) $this->smtpUser=$smtpUserName;
        if (isset($smtpPassword) && !$smtpPass) $this->smtpPass=$smtpPassword;
    }
}


/*
function gmails($from,$to,$subject,$body,$vfrom="",$vto="",$vcc="",$vdate="",$host="localhost",$port="25",$client="")
{
    global $zmailOk,$zmailBlockSize;

    if (isset($zmailOk) && $zmailOk) {
        $tos = array();
        $i=1;
        foreach($to as $t) {
            $tos[]=$t;
            if ($i % $zmailBlockSize == 0) {
                $ret=zmail($from,$tos,$subject,$body,$vfrom,$vto,$vcc,
                           $vdate,$host,$port,$client);
                $tos = array();
            }
            $i++;
        }
        if (isset($tos[0])) {
            $ret=zmail($from,$tos,$subject,$body,$vfrom,$vto,$vcc,
                       $vdate,$host,$port,$client);
        }
    }
    else {
        $header="";
        $eol="\r\n";
        $header.="From: $from$eol";
        $tos="";
        $i=1;
        foreach($to as $t) {
            if ($tos) $tos.=",";
            $tos.=$t;
            if ($i % $zmailBlockSize == 0) {
                $ret=mail($tos,$subject,$body,$header);
                $tos="";
            }
            $i++;
        }
        if ($tos) {
            $ret=mail($tos,$subject,$body,$header);
        }
    }
}
*/
/*
include("stopwatch.php");
$sw = new Stopwatch;

$from="zorum@zorum.com";
$subj="valami";
$vfrom="kuka@itt";
$vcc="";
//$vdate="23 NOV 02 11:12:13 UT";
$vdate="";
$body = <<< EOF
Szevasz!

Ez egy level.
..
.

Regards,
Bela
EOF;
$sw->start();
//$ret=zmail($from,$to,$subj,$body,$from,$to,$vcc,$vdate);
$to="test1@phpoutsourcing.com";
for($i=0;$i<20;$i++) $ret=mail($to,$subj,$body,"From: $from");
$sw->stop();
echo "Elapsed time:".$sw->elapsed()."<br>";
if (isset($rcptErrArr)) {
    foreach($rcptErrArr as $e) {
        echo "rcpt err: $e<br>";
    }
}
if ($ret) echo "$zmailErrStr<br>";
else echo "<br>zmail returned with ok<br>";
echo "<br>".nl2br($zmailSR)."<br>";
echo "<br>END";
*/
/*
Ido teszt eredmenye:

levelszam   zmail2  zmail   mail
1           0.06    0.06    0.06
10          0.4     0.06    0.5
20          0.8     0.1     0.95


*/
?>
