<?php

class ClassifiedsInit extends Init
{
function initializeSystemSettings()
{
    global $defaultMethod,$defaultList, $gorumroll, $gorumglobalstat;
    global $user_typ, $withShoppingCart;
    
    Init::initializeSystemSettings();
    $gorumglobalstat = new GlobalStat;
    $gorumglobalstat->id=1;
    $ret=load($gorumglobalstat);
    if ($gorumglobalstat->defPageConf &&
        $gorumroll->method==$defaultMethod &&
        $gorumroll->list==$defaultList)
    {
        $gorumroll->method = "checkconf";
    }
    if( $withShoppingCart )
    {
        $user_typ["attributes"]["viewOrdersLink"][]="list";
        $user_typ["attributes"]["viewOrdersLink"][]="details";
    }
}

function showApp()
{
    global $gorumcontent,$navBarText,$infoText;
    global $upperTemplate,$lowerTemplate,$lll,$xi,$NS4;

    
    $this->makeLoginMenu($loginMenu);    
    $this->makeUserMenu($userMenu);    
    $this->makeAdminMenu($adminMenu);    
    $this->makeClassifMenu($zorumMenu,$loginMenu,$userMenu);

    $userStatus=$this->showUserStatus();
    $userMenuStr=templateShowMenu($zorumMenu);
    $adminMenuStr=templateShowMenu($adminMenu);
    $footer=$this->showVersionFooter();
    if (!$navBarText) $navBarText="";
    $s=templateMain($userMenuStr,$adminMenuStr,$userStatus,
                    $navBarText,$infoText,$gorumcontent,$footer);
    return $s;
}
function showUserStatus()
{
    global $gorumrecognised,$gorumuser,$lll;
    $s="";
    if ($gorumrecognised) {
       $s.=sprintf($lll["loggedas"],htmlspecialchars($gorumuser->name));
    }
    else $s.=$lll["logorreg"];
    return $s;
}
function display( $what )
{    
    global $withShoppingCart, $gorumrecognised, $gorumroll, $categoryClassName;
    global $showChangePassword;
    global $showLogout;
    global $showLogin;
    global $showRegister;
    global $showMyProfile;
    global $showMyAds;
    global $showSubmitAd;
    global $showRecentAds;
    global $showMostPopularAds;
    global $showSearch;
    global $showHome;
    
    hasAdminRights($isAdm);
    switch( $what )
    {
    case Init_adminhelp:
    case Init_confcheck:
        return $isAdm;
    case Init_myCart:
    case Init_trackPurchases:
        return !$isAdm && $gorumrecognised && $withShoppingCart;
    case Init_recentPurchases:
        return $isAdm && $withShoppingCart;
    case Init_search:
        return $showSearch;
    case Init_register:
        return $showRegister && Init::display($what);
    case Init_login:
        return $showLogin && Init::display($what);
    case Init_cangePwd:
        return $showChangePassword && Init::display($what);
    case Init_logout:
        return $showLogout && Init::display($what);
    case Init_myProfile:
        return $showMyProfile && Init::display($what);
    case Init_myItems:
        return $showMyAds && Init::display($what);    
    case Init_addItem:
        $ret = ($showSubmitAd || $isAdm) && Init::display($what);    
        if( $ret )
        {   
            $cat = new $categoryClassName;
            $cat->id = $gorumroll->rollid;
            load($cat, "", "allowAd");
            $ret = $cat->allowAd;
        }
        return $ret;
    case Init_recentItems:
        return $showRecentAds && Init::display($what);
    case Init_popularItems:
        return $showMostPopularAds && Init::display($what);
    case Init_home:
        return $showHome && Init::display($what);
    default:
        return Init::display($what);           
    }
}
function makeUserMenu(&$menu, $spanCl="")
{
    global $gorumroll,$userClassName,$gorumuser,$lll;
    global $itemClassName, $categoryClassName, $searchClassName, $shoppingCartClassName;

    Init::makeUserMenu($menu, $spanCl);

    // Search form:
    if( $this->display( Init_search ))
    {
        $tempRoll = $gorumroll;
        $tempRoll->list = $searchClassName;
        $tempRoll->method = "create_form";   
        $tempRoll->rollid = 0;
        if( $gorumroll->rollid && $gorumroll->list==$itemClassName && 
            $gorumroll->method=="showdetails" )
        {
            $item = new $itemClassName;
            $item->id = $gorumroll->rollid;
            $item->load();
            $tempRoll->cid = $item->cid;
        }            
        else $tempRoll->cid = $gorumroll->rollid;
        saveInFrom($tempRoll);
        $menu[Init_search]=$tempRoll->generAnchor($lll["search"], $spanCl);        
    }
    if( $this->display( Init_myCart ))
    {
        $tempRoll = $gorumroll;
        $tempRoll->list = $shoppingCartClassName;
        $tempRoll->method = "showhtmllist";   
        $tempRoll->rollid = $gorumuser->id;   
        $menu[Init_myCart]=$tempRoll->generAnchor($lll["myCart"], $spanCl);        
    }
    if( $this->display( Init_trackPurchases ))
    {
        $tempRoll = $gorumroll;
        $tempRoll->list = $shoppingCartClassName."_track";
        $tempRoll->method = "showhtmllist";   
        $tempRoll->rollid = $gorumuser->id;   
        $menu[Init_trackPurchases]=$tempRoll->generAnchor($lll["trackPurchases"], $spanCl);        
    }
}
function makeAdminMenu(&$menu, $spanCl="")
{
    global $gorumroll, $lll, $shoppingCartClassName;
    Init::makeAdminMenu($menu, $spanCl);

    if( $this->display( Init_adminhelp ))
    {
        $menu[Init_adminhelp]="<a href='http://classifieds.phpoutsourcing.com/faq.php' class='$spanCl'>Help</a>";        
    }
    if( $this->display( Init_confcheck ))
    {
        $tempRoll = $gorumroll;
        $tempRoll->method = "checkconf";
        $menu[Init_confcheck]=
            $tempRoll->generAnchor($lll["Init_confcheck"], $spanCl);
    }
    if( $this->display( Init_recentPurchases ))
    {
        $tempRoll = $gorumroll;
        $tempRoll->method = "showhtmllist";
        $tempRoll->list = $shoppingCartClassName."_recent";
        $menu[Init_recentPurchases]=
            $tempRoll->generAnchor($lll["recentPurchases"], $spanCl);
    }
}
function makeClassifMenu(&$menu,$loginMenu,$userMenu)
{
    global $gorumuser, $gorumroll, $userClassName;
    global $gorumauthlevel, $gorumrecognised;
    global $necessaryAuthLevel;
    global $lll;

    //$menu=$loginMenu;

    //$menu[Init_home] = $userMenu[Init_home];
    $menu = array_merge($loginMenu,$userMenu);
}

function generBoxDown()
{
    global $gorumroll, $shoppingCartClassName;
    if( $gorumroll->list==$shoppingCartClassName && $gorumroll->method=="showhtmllist")
    {
        // Ekkor az ShoppingCart::showHtmlList-beli dolgok lepnek ervenybe
        return "";
    }
    return Init::generBoxDown();
}


}
?>
