<?php

$shoppingcart_typ =  
    array(
        "attributes"=>array(   
            "id"=>array(
                "type"=>"INT",
                "auto increment",
                "form hidden"
            ),
            "item"=>array(
                "type"=>"INT",
            ),
            "ownerName"=>array(
                "type"=>"VARCHAR",
                "no column",
            ),
            "title"=>array(
                "type"=>"VARCHAR",
                "no column",
                "list"
            ),
            "amount"=>array(
                "type"=>"INT",
                "default"=>1,
                "list"
            ),
            "price"=>array(
                "type"=>"FLOAT",
                "no column",
                "list"
            ),
            "ownerId"=>array(
                "type"=>"INT",
                "form invisible"
            ),
            "status"=>array(
                "type"=>"INT",
                "default"=>Shoppingcart_new,
            ),
            "orderNumber"=>array(
                "type"=>"VARCHAR",
                "form invisible",
                "max"=>255
            ),
            "orderDate"=>array(
                "type"=>"INT",
                "form invisible",
            ),
            "shippmentDate"=>array(
                "type"=>"INT",
                //"form invisible",
            )
        ),    
        "primary_key"=>"id",
        "delete_confirm"=>"title",
        "sort_criteria_sql"=>"orderDate DESC",
    );
    

class ShoppingCart extends Object
{


function hasObjectRights(&$hasRight, $method, $giveError=FALSE)
{
    global $lll,$generalRight,$gorumrecognised,$gorumuser;
    global $applName,$itemClassName;
    $hasRight=TRUE;
    $generalRight = TRUE;
    if( !$hasRight && $giveError )
    {
        handleError($lll["permission_denied"]);
    }
} 

function create()
{
    global $gorumroll, $lll, $gorumuser, $gorumrecognised;
    global $infoText, $whatHappened, $shoppingCartClassName;
    
    if( !$gorumrecognised )
    {
        $infoText = $lll["loginToPurchase"];
        $whatHappened = "form_submitted";
        return;
    }
    Object::create();
    $gorumroll->fromlist=$shoppingCartClassName;
    $gorumroll->frommethod="showhtmllist";
    $gorumroll->fromid=$gorumuser->id;
    $infoText = $lll["addedToTheCart"];
}

function modify()
{
    global $gorumroll,$infoText, $lll, $gorumuser, $shoppingCartClassName;
    
    $oldCart = new $shoppingCartClassName;
    $oldCart->id = $this->id;
    load($oldCart);
    if( $oldCart->status==Shoppingcart_payed && $this->status==Shoppingcart_processed )
    {
        $this->shippmentDate = time();
    }
    Object::modify();
    //$infoText = $lll["amountModified"];
}

function getListSelect()
{
    global $itemClassName, $applName, $gorumroll,$shoppingCartClassName;
    global $shoppingcart_typ, $userClassName;
    
    hasAdminRights($isAdm);
    if( $gorumroll->list==$shoppingCartClassName."_recent" )
    {
        if( !$isAdm ) handleError("Permission denied");
        $select = "SELECT s.*, i.title AS title, i.price AS price, u.name AS ownerName FROM ".
                  $applName."_$shoppingCartClassName AS s, $applName"."_$itemClassName AS i, ".
                  $applName."_$userClassName AS u ".
                 "WHERE s.item=i.id AND s.ownerId=u.id AND status='".Shoppingcart_payed."'";
        $shoppingcart_typ["attributes"]["ownerName"][]="list";         
    }
    elseif( $gorumroll->list==$shoppingCartClassName."_track" )
    {
        $select = "SELECT s.*, i.title AS title, i.price AS price FROM ".
                  $applName."_$shoppingCartClassName AS s, $applName"."_$itemClassName AS i ".
                 "WHERE s.item=i.id AND s.ownerId=$gorumroll->rollid AND status!='".Shoppingcart_new."'";
        $shoppingcart_typ[]="notools";         
    }             
    else
    {
        $select = "SELECT s.*, i.title AS title, i.price AS price FROM ".
                  $applName."_$shoppingCartClassName AS s, $applName"."_$itemClassName AS i ".
                 "WHERE s.item=i.id AND s.ownerId=$gorumroll->rollid";
        if( $isAdm )
        {
            $select.=" AND status!='".Shoppingcart_new."'";
        }  
        else
        {
            $select.=" AND status='".Shoppingcart_new."'";
        }
    }  
    return $select;
}

function getSelect()
{
    global $itemClassName, $applName, $shoppingCartClassName;
    
    $select = "SELECT s.*, i.title AS title, i.price AS price FROM ".
              $applName."_$shoppingCartClassName AS s, $applName"."_$itemClassName AS i ".
             "WHERE s.item=i.id AND s.id='$this->id'";
    return $select;
}

function showListVal($attr)
{
    global $lll,$gorumroll, $totalPrice, $itemClassName, $shoppingCartClassName;
    global $currency;
    
    hasAdminRights($isAdm);
    $s="";
    if( $attr=="price" )
    {
        $price = $this->amount*$this->price;        
        if( $this->status==Shoppingcart_new ) $totalPrice += $price;
        $s = sprintf ("$currency%01.2f", $price);
    }
    elseif( $attr=="amount" ) {
        if( !$isAdm && $gorumroll->list==$shoppingCartClassName)
        {
            $values = array();
            for($i=1; $i<=50; $i++ ) $values[]=$i;
            $s=generSelectField("$this->id",$lll["shoppingcart_amount"],"",$values, $values,
                          $this->amount,1,"","", FALSE, "reloadForm(this.name, this.selectedIndex, \"amount\")", "", "", FALSE);
        }
        else $s=Object::showListVal($attr);                  
    }
    elseif( $attr=="title" ) {
        $tempRoll = new Roll;
        $tempRoll->list = $itemClassName;
        $tempRoll->method = "showdetails";
        $tempRoll->rollid = $this->item;
        saveInFromFrom($tempRoll);
        $s= $tempRoll->generAnchor($this->title);
    }
    elseif( $attr=="ownerName" ) {
        $tempRoll = new Roll;
        $tempRoll->list = $shoppingCartClassName;
        $tempRoll->method = "showhtmllist";
        $tempRoll->rollid = $this->ownerId;
        $s= $tempRoll->generAnchor($this->ownerName);
    }
    elseif( $attr=="orderDate" ) {
        if( $this->status==Shoppingcart_new )
        {
            $s="N/A";
        }
        else $s=sprintf( $lll["ordered"], showTimeStamp($this->orderDate));
        if( $this->status==Shoppingcart_processed )
        {
            $s.=" - ".sprintf( $lll["shipped"], showTimeStamp($this->shippmentDate));
        }    
    }
    elseif( $attr=="orderNumber" ) {
        $s=$this->orderNumber ? $this->orderNumber : "N/A";
    }
    elseif( $attr=="status" ) {
        if( $isAdm && $this->status==Shoppingcart_payed && 
            $gorumroll->method=="showhtmllist")
        {
            $values = array(Shoppingcart_payed, Shoppingcart_processed);
            $labels = array($lll["shoppingcart_status_".Shoppingcart_payed], $lll["shoppingcart_status_".Shoppingcart_processed]);
            $s=generSelectField("$this->id",$lll["shoppingcart_amount"],"", $labels,$values,
                          $this->status,1,"","", FALSE, "reloadForm(this.name, this.selectedIndex, \"status\")", "", "", FALSE);
        }
        else $s=$lll["shoppingcart_status_".$this->status];           
    }
    else $s=Object::showListVal($attr);
    return $s;
}

function showHtmlList(&$s)
{
    global $scriptName, $totalPrice, $colspNum, $lll, $gorumroll;
    global $shoppingcart_typ,$mainBoxWidth,$mainBoxPadding, $gorumuser;
    global $infoText, $whatHappened, $list2Colors, $shoppingCartClassName;
    global $userClassName, $currency;
    
    hasAdminRights($isAdm);
    $s="";
    $list2Colors=TRUE;

    $totalPrice=0;  // a showListVal-ban fog novekedni    
    if( $isAdm && $gorumroll->list==$shoppingCartClassName) 
    {
        $owner = new $userClassName;
        $owner->id = $gorumroll->rollid;
        load($owner);
        $tempRoll = new Roll;
        $tempRoll->list = $userClassName;
        $tempRoll->method = "showdetails";
        $tempRoll->rollid = $gorumroll->rollid;
        saveInFromFrom($tempRoll);
        $userLink = $tempRoll->generAnchor($owner->name);
        $lll[$shoppingCartClassName."_ttitle"]=sprintf($lll["usersShoppingCart"], $userLink );
    }    
    if( $isAdm || $gorumroll->list==$shoppingCartClassName."_track") 
    {
        $shoppingcart_typ["attributes"]["status"][]="list";
        $shoppingcart_typ["attributes"]["orderNumber"][]="list";
        $shoppingcart_typ["attributes"]["orderDate"][]="list";
    }    
    Object::showHtmlList($s1);
    $s.=$s1;
    if( !$isAdm && $gorumroll->list==$shoppingCartClassName)
    {
        $s.="<tr>";
        $cp = $colspNum-1;
        $s.="<td class='extraheader' colspan='$cp' align='right'>";
        $s.="<b>$lll[total]</b>";            
        $s.="</td>\n";
        $s.="<td class='extraheader' colspan='1'>";
        $s.= sprintf ("$currency%01.2f", $totalPrice);
        $s.="</td></tr>\n";
    }
    if( $totalPrice && !$isAdm && $gorumroll->list==$shoppingCartClassName)
    {
        $s.="<tr><td class='header' colspan='$colspNum'>";
        $s.="<center><input type='submit' value='".$lll["purchase"].
            "' name='submit' class='button'></center>\n";            
        $s.="</td></tr>\n";
    }
    $s.=Init::generBoxDown();
    // A script, ami ujratolti az oldalt ha a juzer atallitja az 
    // amount-ot, vagy ha az admin atallitja a statust:
    $now = time();
    $s.="                      
    <SCRIPT LANGUAGE='JavaScript'>
    <!--
    function reloadForm(item, selected, attr)     
    {
        selected++;
        if( attr=='status' ) selected++;
        location='index.php?method=modify&list=$shoppingCartClassName&id='+
                 item+'&'+attr+'='+selected+
                 '&frommethod=showhtmllist&fromlist=$gorumroll->list&fromid=$gorumroll->rollid';
    }
    -->
    </script>
    ";
    if( !$isAdm )
    {
        $s.="</form>\n";
        
        // azert itt hozzuk letre a form headert, mert itt ismert a totalPrice:
        $formHeader="<form method='post' enctype='multipart/form-data'";    
        $formHeader.=" action='https:/"."/payflowlink.verisign.com/payflowlink.cfm?".
                 "MFCIsapiCommand=Orders&LOGIN=MyInteractiveJournal&PARTNER=VSA&".
                 "AMOUNT=$totalPrice&TYPE=S&CUSTID=$gorumuser->id&".
                 "NAME=".urlencode($gorumuser->fullName)."&ADDRESS=".urlencode($gorumuser->address)."&CITY=".urlencode($gorumuser->city)."&".
                 "ZIP=".urlencode($gorumuser->zipCode)."&STATE=".urlencode($gorumuser->state).
                 "&COUNTRY=AUSTRALIA'>\n";
        $s = "$formHeader $s";         
    }
}

function showNewTool()
{
    return "";
}

function showDetailsTool()
{
    return "";
}

function showModTool()
{
    return "";
}

}// end class

function paymentProcessed()
{
    global $HTTP_POST_VARS, $shoppingCartClassName, $applName;
    global $infoText, $userClassName, $itemClassName;
    
    $owner = new $userClassName;    
    $owner->id = $HTTP_POST_VARS["CUSTID"];
    load($owner);
    if( $HTTP_POST_VARS["RESULT"]!=0 )
    {
        return;
    }
    $query = "SELECT SUM(i.price*s.amount) FROM $applName"."_$shoppingCartClassName AS s, $applName"."_$itemClassName AS i ".
             "WHERE s.item=i.id AND s.ownerId='$owner->id' AND s.status='".Shoppingcart_new."'";
    $row=mysql_fetch_row(executeQuery($query));
    $totalPrice = $row[0];
    // manipulalt url:
    if( round($HTTP_POST_VARS["AMOUNT"], 2)!=round($totalPrice, 2) ||
        $HTTP_POST_VARS["TYPE"]!="S" )
    {
        return;
    }    
    // mailt kuldunk rola a adminnak:
    $n = new Notification;
    $n->id = Notification_newPurchase;
    $n->load();
    if( $n->active )
    {
        $tempRoll = new Roll;
        $tempRoll->list = $userClassName;
        $tempRoll->method = "showdetails";
        $tempRoll->rollid = $owner->id; 
        $userLink = $tempRoll->makeUrl("mixed");
        $tempRoll = new Roll;
        $tempRoll->list = $shoppingCartClassName;
        $tempRoll->method = "showhtmllist";
        $tempRoll->rollid = $owner->id; 
        $orderLink = $tempRoll->makeUrl("mixed");
        //$n->send( "", "$owner->firstName $owner->lastName", $userLink, $orderLink );
        $n->send( "", "$owner->name", $userLink, $orderLink );
    }
    $query = "UPDATE $applName"."_$shoppingCartClassName ".
             "SET status='".Shoppingcart_payed."', orderNumber='".
             $HTTP_POST_VARS["PNREF"]."', orderDate='".time()."' ".
             "WHERE ownerId='$owner->id' AND status='".Shoppingcart_new."'";
    executeQuery($query);
    // Elmentjuk a shipping infot:
    $owner->fullName = $HTTP_POST_VARS["NAME"];
    $owner->address = $HTTP_POST_VARS["ADDRESS"];
    $owner->city = $HTTP_POST_VARS["CITY"];
    $owner->state = $HTTP_POST_VARS["STATE"];
    $owner->zipCode = $HTTP_POST_VARS["ZIP"];
    // A konkret modify a kovetkezo fuggvenyben kell hogy megtortenjen:
    $owner->applyPurchaseActions($HTTP_POST_VARS["PNREF"]);
    // Ez a fg arra jo, hogy a leszarmaztatott applikacioban 
    // megtehessunk nehany spec dolgot attol fuggoen, hogy mit is 
    // vasarolt a juzer. Pl. ha membershipet vasarolt, akkor meg kell
    // ot hosszabbitani.
    $whatHappened = "form_submitted";
    $infoText = "Purchase successfull";
}

function customerReturn()
{
    global $HTTP_POST_VARS, $shoppingCartClassName;
    global $whatHappened, $lll, $infoText, $gorumroll, $gorumuser;
    
    if( $HTTP_POST_VARS["RESULT"]=0 )
    {
        $infoText = $lll["purchaseSuccessfull"];
    }
    else $infoText = $lll["purchaseFailed"].": ".$HTTP_POST_VARS["RESULT"];
    $whatHappened = "form_submitted";
}

function callbackFailed()
{
    global $HTTP_POST_VARS, $shoppingCartClassName;
    global $whatHappened, $lll, $infoText, $gorumroll, $gorumuser;
    
    $s = "boooo";
    $whatHappened = "form_submitted";
    $infoText = $lll["purchaseFailedNetworkError"];
}

?>
