<?php
/*
This is a template file for the classifieds application.
If you are not a programmer, it won't be easy for you to modify it.
If you are a programmer it will be really easy to modify.

We think there is no need for very deep explanation what and where
you should change. The names of the functions and variables show
their role.

All functions have some input parameters and produce a string called $s
which will be sent back to the caller function as a return value.

Feel free to modify the functions and give a better look to your
application. Don't forget to change the styleheet in the style.css
if you want to modify your colors.
*/
$catColors[0][0]="#999900";
$catColors[0][1]="#cccc66";
$catColors[1][0]="#ff9900";
$catColors[1][1]="#ffcc99";
$catColors[2][0]="#cc6600";
$catColors[2][1]="#e6b380";
$catColors[3][0]="#cc9933";
$catColors[3][1]="#ffcc66";
$catSp="7";
function templateMain($userMenuStr,$adminMenuStr,$userStatus,
                      $navBarText,$infoText,$gorumcontent,$footer)
{
/*
Description:
    This is the main show function.
Input parameter:
    The names of the parameter show which part of the page contained
    in the strings.
    $gorumcontent is the main part of the page generated by the program.
*/
    global $xi;
    $s="";

    $s.="<center>";
    $s.="<span class='userstatus'>$userStatus</span>\n";
    $s.=vertSpacer("3");
    $s.=$userMenuStr;
    if ($adminMenuStr) {
        $s.=vertSpacer("3");
        $s.=$adminMenuStr;
    }
    if ($navBarText) {
        $s.=vertSpacer("30");
        $s.="<table border='0' cellpadding='0' cellspacing='0'>";
        $s.="<tr>";
        $s.="<td><img src='$xi/b.gif' width='15'></td>\n";
        $s.="<td class='navBar'>$navBarText";
        $s.="</td></tr></table>\n";
    }
    if( $infoText ) {
        $s.=vertSpacer();
        $s.=templateShowAppInfoText($infoText)."\n";
    }
    if ($navBarText) {
        $s.=vertSpacer();
    }
    else {
        $s.=vertSpacer(42);
    }
    $s.=$gorumcontent;
    $s.=vertSpacer("20");
    $s.=templateShowVersionFooter();
    return $s;
}

function templateShowAppInfoText($txt)
{
/*
Description:
    This function will display the result of an operation a user
    has made, eg: cliking on a button such as: Cancel, OK etc.
Input parameter:
    The text of message to be displayed.
*/
    global $xi;
    $s="";
    $s.="<span class='infoText'>$txt</span>\n";
    return $s;
}
function templateShowVersionFooter()
{
    global $gorumglobalstat,$lll;
    $s="";
    $s.=vertSpacer();
    $s.="<center><span class='powfooter'>Powered by ".
        "<a href='http://classifieds.phpoutsourcing.com/' class='powfooter'>".
        "Noah's Classifieds</a> ";
    $s.=str_replace("_", ".", $gorumglobalstat->instver);
    $s.=" - <a href='http://classifieds.phpoutsourcing.com/donate.php'".
        " class='powfooter'>Donate Noah's Classifieds</a>";
    $s.="</span></center>";
    return $s;
}
function templateShowMenu($menu)
{
/*
Description:
    The menu items will be displayed.
Input parameter:
    Array. The elements of the array are the menu items.
*/
    global $xi;

    $s="";
    $s.="<table border='0' cellpadding='0' cellspacing='0'>";
    $s.="<tr valign='middle'>";
    $first=TRUE;
    foreach($menu as $id=>$menuPoint) {
        if (!$first) {
            $s.="<td>\n";
            $s.="&nbsp;";
            $s.="</td>";
            $s.="<td align='center' valign='middle'>";
            $s.="<img src='$xi/menusep.gif' width='8' height='8'>";
            $s.="</td>";
            $s.="<td>\n";
            $s.="&nbsp;\n";
            $s.="</td>";
        }
        $s.="<td class='mainmenu' nowrap>\n";
        $s.=$menuPoint;
        $s.="</td>\n";
        $first=FALSE;
    }
    $s.="</td></tr>";
    $s.="</table>";
    return $s;
}
function templateShowCat($catArr,$adListStr)
{
/*
Description:
    Displays the categories.
Input parameter:
    $catArr: Array. The elements of the array are the category objects.
             The format of the objects is described in the
             function templateShowOneCat.
    $adListStr: The string to add new items to the category.
*/
    global $xi,$catColors;
    $s="";
    $colNum=4;
    $s.="<table border='0' cellpadding='0' cellspacing='0'>";
    $s.="<tr>";
    $i=0;
    foreach($catArr as $item) {
        if (($i % $colNum) == 0) $s.="<tr>";        
        $s.="<td><img src='$xi/b.gif' width='2'></td>";
        $s.="<td valign='top'>";
        $s.=templateShowOneCat($item);
        $s.="</td>\n";
        if ((($i+1) % $colNum) == 0) {
            $s.="</tr>\n<tr><td colspan='$colNum'><img src='$xi/b.gif' height='2'></td></tr>\n";
        }
        $i++;
    }
    while ((($i+1) % $colNum) == 0) {
        $s.="<td>&nbsp;</td></tr>\n";
        $i++;
    }
    $s.="</tr>";
    $s.="</table>\n";
    $s.=vertSpacer();
    $s.=$adListStr;
    return $s;
}
function templateShowOneCat($cat)
{
/*
Description:
    Displays one category.
Input parameter:
    $cat: Object.
            Fields: title, description, pic.
*/
    $s="";
    $s.="<table border='0'>";
    $s.="<tr><td class='categ'>$cat->title</td></tr>\n";
    $s.="<tr><td class='catdesc'>$cat->description</td></tr>\n";
    if ($cat->pic) {
        $s.="<tr><td class='catdesc'>$cat->pic</td></tr>\n";
    }
    $s.="</table>\n";
    return $s;
}
?>
